#require "perkins/version"
$:.unshift(File.dirname(__FILE__)) unless $:.include?(File.dirname(__FILE__)) || $:.include?(File.expand_path(File.dirname(__FILE__)))

require "logger"
require 'active_support/core_ext'
require 'redis'
require 'redis-namespace'
require "travis/yaml"
require "active_record"
require "sidekiq"

require 'dotenv'
Dotenv.load
require 'octokit'
Octokit.auto_paginate = true
#require 'core_ext/hash/deep_symbolize_keys'
require 'core_ext/string/color'

module Perkins
    autoload  :VERSION, 'perkins/version.rb'
    autoload  :Repo,  'perkins/repo.rb'
    autoload  :BuildReport,  'perkins/build_report.rb'
    autoload  :Runner,  'perkins/runner.rb'
    autoload  :Build,  'perkins/build.rb'
    autoload  :Commit,  'perkins/commit.rb'
    autoload  :Server,  'perkins/server.rb'
    autoload  :BuildWorker,  'perkins/build_worker.rb'
    autoload  :GitLoaderWorker,  'perkins/git_loader_worker.rb'
    autoload  :ThorUtils, 'perkins/thor_utils.rb'
    autoload  :Logger,  'perkins/logger.rb'
    autoload  :Application,  'perkins/application.rb'
    autoload  :AppProxy,  'perkins/dsl/app_proxy.rb'
    autoload  :CLI,  'perkins/cli.rb'
    ROOT_PATH = File.expand_path(File.dirname(File.dirname(__FILE__)))
end

require 'perkins/dsl'

