module Perkins
  module Build
    class Script
      module Stages

        def run_stages
          STAGES[:builtin].each { |stage| run_builtin_stage(stage) }
          STAGES[:custom].each  { |stage| run_stage(stage) }
        end

        def run_builtin_stage(stage)
          self.send(stage)
        end

        def run_stage(stage)
          puts "call #{stage}"
          call_custom_stage(stage)
        end

        def call_custom_stage(stage)
          @config.send(stage).present? ? cmd(@config.send(stage)) : self.send(stage)
        end

      end
    end
  end
end